/*
 * 90CAN_extID_test.c
 *
 * Created: 08.03.2019 19:13:34
 * Author : Ich
 */ 

#include <avr/io.h>
#include <avr/interrupt.h>

volatile uint8_t ms_tick = 0;


// wird alle 10ms aufgerufen
ISR (TIMER3_COMPA_vect)																			
{
	ms_tick = 42;								
}
	

void timer3_init(void)
{
	TCCR3B = 0x00;
	OCR3A = 19999;
	TIMSK3 |= (1<<OCIE3A);
	TCCR3B |= (1<<WGM32) | (1<<CS31);
}



void can_init(void)
{
	uint8_t i,j;
	uint32_t id;

	CANGCON = (1<<SWRES);

	for (i=0; i<15; i++)
	{
		CANPAGE = (i<<4);
		CANCDMOB = 0;
		CANSTMOB = 0x00;
		CANIDT1 = 0x00;
		CANIDT2 = 0x00;
		CANIDT3 = 0x00;
		CANIDT4 = 0x00;
		CANIDM1 = 0x00;
		CANIDM2 = 0x00;
		CANIDM3 = 0x00;
		CANIDM4 = 0x00;
		
		for (j=0; j<8; j++)
		{
			CANMSG = 0x00;
		}
	}

// Einstellung fr eine 250 kBit/s Baudrate mit 16 MHz Quarzoszillator
	
	//CN bit timing register
	
	CANBT1 = 0x06;
	CANBT2 = 0x0C;
	CANBT3 = 0x37;

	CANGCON = (1<<ENASTB);	// Aktivieren des CAN-Busses

	id = 0x18FF50E5;
	id = (id << 3);
	CANPAGE = (0<<4);	// Auswhlen des MOB0
	CANIDT	= id;
	CANIDM1 = 0xFF;
	CANIDM2 = 0xFF;
	CANIDM3 = 0xFF;
	CANIDM4 = 0xF8 | (1<<IDEMSK);	// setzen der identifier extension mask
	CANCDMOB = (1<<CONMOB1) | (1<<IDE) | 8;	// Empfangsmodus eingeschaltet fr 8 Byte Nachrichtenlnge
		
	id = 0x1806E5F4;
	id = (id << 3);
	CANPAGE = (1<<4);	// Auswhlen des MOB1
	CANIDT	= id;
	CANIDM1 = 0xFF;
	CANIDM2 = 0xFF;
	CANIDM3 = 0xFF;
	CANIDM4 = 0xF8 | (1<<IDEMSK);	// setzen der identifier extension mask
	CANCDMOB = (1<<IDE) | 8;	// Sendemodus eingeschaltet fr 8 Byte Nachrichtenlnge
	CANSTMOB |= (1<<TXOK);

	CANGIE =  0x00;
	CANIE1 =  0x00;
	CANIE2 =  0x00;
	CANSIT1 = 0x00;
	CANSIT2 = 0x00;
}


int main(void)
{
	uint8_t can_delay = 0;

	uint8_t Byte1 = 0;
	uint8_t Byte2 = 0;
	uint8_t Byte3 = 0;
	uint8_t Byte4 = 0;
	uint8_t Byte5 = 0;
	uint8_t Byte6 = 0;
	uint8_t Byte7 = 0;
	uint8_t Byte8 = 0;

	cli();
	timer3_init();
	can_init();
	sei();

    while (1) 
    {
		if(ms_tick)
		{
			ms_tick = 0;
			
			CANPAGE = (0<<4);					// Auswhlen des MOB0
			if(CANSTMOB & (1<<RXOK))			// Wurden Daten Empfangen?
			{
				Byte1= CANMSG;					//Empfangene Nachricht in Byte1-8 abspeichern 
				Byte2= CANMSG;
				Byte3= CANMSG;
				Byte4= CANMSG;
				Byte5= CANMSG;
				Byte6= CANMSG;
				Byte7= CANMSG;
				Byte8= CANMSG;

				CANSTMOB &= ~(1<<RXOK);			// Reset Flag
				CANCDMOB = (1<<CONMOB1) |(1<<IDE)|  8;	// Empfangsmodus eingeschaltet fr 8 Byte Nachrichtenlnge
			}

			can_delay++;
			if(can_delay > 9)
			{
				can_delay = 0;
				
				CANPAGE = (1<<4);				// Auswhlen des MOB1
				if(CANSTMOB & (1<<TXOK))		// Senden beendet?
				{
					CANSTMOB &= ~(1<<TXOK);		// Reset flag
					
					CANMSG = Byte1;		
					CANMSG = Byte2;		
					CANMSG = Byte3;			
					CANMSG = Byte4;				
					CANMSG = Byte5;				
					CANMSG = Byte6;				
					CANMSG = Byte7;			
					CANMSG = Byte8;			
						
					CANCDMOB |= (1<<CONMOB0);	// CAN bertragung einleiten
				}
				
			}
		}
	}
}	